AutoMoDe-Mate and EvoSpace README
================================================================================================

```
________________________________________________________________________________________________
|.............................................MATE.............................................|
|______________________________________________________________________________________________|
|..............................................................................................|
|.................................................*............................................|
|................................................*.............................................|
|...............................................*..............................................|
|............................................*****.............................................|
|..........................................*********...........................................|
|........................................*************.........................................|
|........................................*************.........................................|
|.........................................***********..........................................|
|...........................................*******............................................|
|______________________________________________________________________________________________|
```

# Table of Contents

- [Installation](#Installation)
- [Run AutoMoDe](#Run-AutoMoDe)

## Installation

First, compile the dependences: `argos3`, `argos3-epuck`, `demiurge-epuck-dao`, `experiments-loop-functions`:

#### ARGoS simulator

On Linux, install these dependences:

```
$sudo apt-get install cmake libfreeimage-dev libfreeimageplus-dev \
  qt5-default freeglut3-dev libxi-dev libxmu-dev liblua5.3-dev \
  lua5.3 doxygen graphviz graphviz-dev asciidoc
```

Compile and install `argos3` (this is `argos3` version 48):

```
$ cd argos3
$ mkdir build
$ cd build
$ cmake ../src
$ make
$ make doc
$ sudo make install
```

#### ARGoS epuck plugin

Compile and install `argos3-epuck` (this is `argos3-epuck` version 48):

```
$ cd argos3-epuck
$ mkdir build
$ cd build
$ cmake ../src
$ make
$ sudo make install
```

#### epuck DAO

Compile and install `demiurge-epuck-dao`.

```
$ cd demiurge-epuck-dao
$ mkdir build
$ cd build
$ cmake ..
$ make
$ sudo make install
```

#### Experiments loop functions

Compile and install `experiments-loop-functions`.

```
$ cd experiments-loop-functions
$ mkdir build
$ cd build
$ cmake ..
$ make
$ sudo make install
```

#### AutoMoDe-Mate

Compile `ARGoS3-AutoMoDe`:

```
$ cd ARGoS3-AutoMoDe
$ mkdir build
$ cd build
$ cmake ..
$ make
```

## Run AutoMoDe-Mate

For example, to run a mission `mate_apc_visu.xml` with the simple finite state machine `--nstates 1 --s0 4 --att0 5`, open a terminal and copy this command:

```
$ cd ~/Mate/AutoMoDe-Mate/bin
$ ./automode_main -c ../experiments/mate/mate_apc_visu.xml --seed 0 --readable-fsm --fsm-config --nstates 1 --s0 4 --att0 5
```

## EvoSpace

Compile `ARGoS3-NEAT`:

```
$ cd ARGoS3-NEAT
$ mkdir build
$ cd build
$ cmake ../
$ make
```

## Run EvoSpace

For example, to run a mission `neat_apc_visu.xml` with the simple controller `gen_0`, open a terminal and copy this command:

```
$ cd ~/Mate/ARGoS3-NEAT/bin
$ ./NEAT-launch -c ../experiments/mate/neat_apc_visu.xml -g gen/apc/gen_0
```
